(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('primeng/dialog'), require('primeng/button'), require('jny-pre-http-services'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('jny-user-picker', ['exports', '@angular/core', '@angular/common', '@angular/forms', 'primeng/dialog', 'primeng/button', 'jny-pre-http-services', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['jny-user-picker'] = {}, global.ng.core, global.ng.common, global.ng.forms, global.dialog, global.button, global.i1, global.rxjs));
}(this, (function (exports, i0, common, forms, dialog, button, i1, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var JnyUserPickerService = /** @class */ (function () {
        function JnyUserPickerService() {
            this.dialogAlertSubject = new rxjs.Subject();
        }
        // ===== loginModal (START)=====
        JnyUserPickerService.prototype.showDialogAlert = function (_header, _content) {
            this.sendDialogAlertSubject({
                display: true,
                header: _header,
                content: _content
            });
        };
        JnyUserPickerService.prototype.sendDialogAlertSubject = function (obj) {
            this.dialogAlertSubject.next(obj);
        };
        JnyUserPickerService.prototype.getDialogAlertSubject = function () {
            return this.dialogAlertSubject.asObservable();
        };
        return JnyUserPickerService;
    }());
    JnyUserPickerService.ɵprov = i0.ɵɵdefineInjectable({ factory: function JnyUserPickerService_Factory() { return new JnyUserPickerService(); }, token: JnyUserPickerService, providedIn: "root" });
    JnyUserPickerService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    JnyUserPickerService.ctorParameters = function () { return []; };

    var JnyUserPickerComponent = /** @class */ (function () {
        function JnyUserPickerComponent(httpService, jnyUserPickerService) {
            this.httpService = httpService;
            this.jnyUserPickerService = jnyUserPickerService;
            this.ctrlUrl = 'osjcEmpCtrl/';
            this.selectEmpDept = '---';
            this.selectEmpName = '---';
            this.valueChange = new i0.EventEmitter();
            this.userInfo = new i0.EventEmitter();
            this.STORAGE_KEY = 'JNY_loginUser';
            this.isLoading = false;
            this.selectEmp = {
                deptNo: '',
                userNo: '',
                cname: ''
            };
        }
        JnyUserPickerComponent.prototype.ngOnChanges = function (changes) {
            // 決定不處理 selectEmpName 和 selectEmpDept
            // 只要傳入工號 value 就觸發查詢
            for (var propertyName in changes) {
                if (propertyName === "value") {
                    var change = changes[propertyName];
                    // 也不管之前的值為何, 就丟去changeUser做檢查並查詢
                    // let cur  = JSON.stringify(change.currentValue);
                    // let prev = JSON.stringify(change.previousValue);
                    this.changeUser();
                }
            }
        };
        JnyUserPickerComponent.prototype.ngOnInit = function () {
        };
        JnyUserPickerComponent.prototype.changeUser = function () {
            // 避免valueEmit之後又再觸發changeUser事件
            if (this.selectEmp.userNo === this.value) {
                return false;
            }
            if (this.value.length !== 6) {
                this.selectEmpDept = '---';
                this.selectEmpName = '---';
                this.userInfo.emit({ empNo: '', empName: '', empDept: '' });
            }
            else {
                this.selectEmp.userNo = this.value;
                this.checkAuth();
            }
        };
        JnyUserPickerComponent.prototype.qryEmp = function (deptNo) {
            return this.httpService.post(this.ctrlUrl + 'qryEmp', deptNo);
        };
        // 挑選部門
        JnyUserPickerComponent.prototype.pickDept = function () {
            var _this = this;
            this.qryEmp(this.selectDept).subscribe(function (carrier) {
                _this.setEmpVos(carrier);
                _this.addAuth();
            }, function (error) { return console.log(error); });
        };
        JnyUserPickerComponent.prototype.pickUser = function (event) {
            this.checkAuth();
        };
        // 查詢目前登入的人是否有此使用者權限
        JnyUserPickerComponent.prototype.checkAuth = function () {
            var _this = this;
            var params = { userId: this.selectEmp.userNo };
            //this.httpService.post('oajcContactCtrl/queryEmpNoForPicker', params).subscribe(
            this.isLoading = true;
            this.httpService.post(this.ctrlUrl + 'queryEmpByUserId', params).subscribe(function (data) {
                _this.setValueEmit(data);
                _this.isLoading = false;
                _this.setuidTextFocus();
            }, function (error) {
                console.log(error);
                _this.isLoading = false;
                _this.setuidTextFocus();
            });
        };
        JnyUserPickerComponent.prototype.setValueEmit = function (data) {
            if (data.attributeMap.userInfo.empNo === '') {
                this.value = '';
                this.selectEmpDept = '---';
                this.selectEmpName = '---';
            }
            else {
                this.value = data.attributeMap.userInfo.empNo;
                this.selectEmpDept = data.attributeMap.userInfo.deptNo;
                this.selectEmpName = data.attributeMap.userInfo.empName;
            }
            this.visible = false;
            this.valueChange.emit(this.value);
            this.userInfo.emit(data.attributeMap.userInfo);
        };
        // 開啟使用者挑選清單
        JnyUserPickerComponent.prototype.showUserPicker = function () {
            this.queryDeptVOs();
            this.getUserByDept();
            //  this.getUserInfo();
        };
        // 依照部門代碼取得使用者清單
        JnyUserPickerComponent.prototype.getUserByDept = function () {
            var loginUserVO = this.getLoginUser();
            if (this.value != null && this.value !== '') {
                // 使用者輸入欄已有值時，預設將使用者選單選到該選項,部門選單則不選到任何值
                this.selectDept = '';
                this.qryEmpBySameDept(this.value);
            }
            else {
                // 使用者輸入欄無值時，選單預設選到為登入者的部門和職鯿
                this.selectDept = loginUserVO.deptNo;
                this.qryEmpBySameDept(loginUserVO.userId);
            }
            this.visible = true;
        };
        JnyUserPickerComponent.prototype.qryEmpBySameDept = function (empNo) {
            var _this = this;
            this.httpService.post(this.ctrlUrl + 'qryEmpBySameDept', empNo).subscribe(function (carrier) {
                _this.setEmpVos(carrier);
                _this.selectEmp.userNo = empNo;
            }, function (error) { console.error(error); });
        };
        JnyUserPickerComponent.prototype.setEmpVos = function (carrier) {
            var e_1, _a;
            var mapArray = carrier.attributeMap['empList'];
            this.empVOs = new Array();
            try {
                for (var mapArray_1 = __values(mapArray), mapArray_1_1 = mapArray_1.next(); !mapArray_1_1.done; mapArray_1_1 = mapArray_1.next()) {
                    var map = mapArray_1_1.value;
                    var empVO = new EmpVO();
                    empVO.userNo = map['USERNO'];
                    empVO.cname = map['CNAME'];
                    empVO.deptNo = map['DEPTNO'];
                    empVO.hasAuth = '0';
                    this.empVOs.push(empVO);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (mapArray_1_1 && !mapArray_1_1.done && (_a = mapArray_1.return)) _a.call(mapArray_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        // empVOs 添加 auth 權限
        JnyUserPickerComponent.prototype.addAuth = function () {
            var auth_list = JSON.parse(sessionStorage.getItem('auth-list'));
            if (auth_list == null) {
                return;
            }
            this.empVOs.forEach(function (mval) {
                auth_list.forEach(function (aval) {
                    if (mval.userNo === aval.empNo) {
                        mval.hasAuth = aval.hasAuth;
                    }
                });
            });
        };
        JnyUserPickerComponent.prototype.queryDeptVOs = function () {
            var _this = this;
            this.httpService.post(this.ctrlUrl + 'qryAllDept').subscribe(function (carrier) {
                var e_2, _a;
                var mapArray = carrier.attributeMap['deptList'];
                _this.deptVOs = new Array();
                try {
                    for (var mapArray_2 = __values(mapArray), mapArray_2_1 = mapArray_2.next(); !mapArray_2_1.done; mapArray_2_1 = mapArray_2.next()) {
                        var map = mapArray_2_1.value;
                        var deptVO = new DeptVO();
                        deptVO.deptNo = map['DEPTNO'];
                        deptVO.deptName = map['DEPTNAME'];
                        _this.deptVOs.push(deptVO);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (mapArray_2_1 && !mapArray_2_1.done && (_a = mapArray_2.return)) _a.call(mapArray_2);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }, function (error) { return console.log(error); });
        };
        JnyUserPickerComponent.prototype.getLoginUser = function () {
            var loginUserVO = JSON.parse(sessionStorage.getItem(this.STORAGE_KEY));
            if (loginUserVO == null || loginUserVO === undefined) {
                return new LoginUserVO();
            }
            else {
                return loginUserVO;
            }
        };
        JnyUserPickerComponent.prototype.setuidTextFocus = function () {
            var _this = this;
            setTimeout(function () {
                _this.uidTextElement.nativeElement.focus();
            }, 0);
        };
        return JnyUserPickerComponent;
    }());
    JnyUserPickerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-jny-user-picker',
                    template: "<style>\r\n  .myBox {\r\n    display: inline-block;\r\n  }\r\n</style>\r\n\r\n<div class=\"p-inputgroup\" style='width:180px'>\r\n  <button type=\"button\" pButton pRipple icon=\"pi pi-user\" styleClass=\"p-button-info\"\r\n    (click)=\"showUserPicker()\"></button>\r\n  <input type=\"text\" pInputText [(ngModel)]=\"value\" (input)=\"changeUser()\" maxlength=\"6\"\r\n    class='p-inputtext p-component' [disabled]=\"isLoading\" #uidText>\r\n  <span class=\"p-inputgroup-addon\"><span class=\"badge badge-info mr-1\">{{selectEmpDept}}</span>{{selectEmpName}}</span>\r\n</div>\r\n\r\n<p-dialog header=\"\u4EBA\u54E1\u9078\u55AE\" [(visible)]=\"visible\" [modal]=\"true\" [responsive]=\"true\"\r\n  [style]=\"{width: '450px', minWidth: '400px'}\" [baseZIndex]=\"9999\">\r\n  <div style=\"text-align: center\">\r\n    <div class=\"myBox\">\r\n      <!--\u56E0IE\u4E0B\u62C9\u9078\u55AEoption\u6C92\u6709click\u4E8B\u4EF6\uFF0C\u6545\u5BEB\u5728select\u4E2D-->\r\n      <select [(ngModel)]=\"selectDept\" size=\"20\" (click)=\"pickDept()\" style=\"width:200px\">\r\n        <option *ngFor=\"let deptVO of deptVOs\" [value]=\"deptVO.deptNo\">{{deptVO.deptNo + ' '+ deptVO.deptName}}</option>\r\n      </select>\r\n    </div>\r\n    <div class=\"myBox\" style=\"margin-left:10px;\">\r\n      <select [(ngModel)]=\"selectEmp\" size=\"20\" (click)=\"pickUser($event)\" id=\"pickUserSelect\" style=\"width:160px\">\r\n        <option *ngFor=\"let empVO of empVOs\" [ngValue]=\"empVO\">\r\n          <!--[disabled]=\"empVO.hasAuth!=='1'\"-->\r\n          <!--[value]=\"empVO.userNo\"-->\r\n          {{empVO.cname}}\r\n        </option>\r\n      </select>\r\n    </div>\r\n  </div>\r\n</p-dialog>\r\n",
                    providers: []
                },] }
    ];
    JnyUserPickerComponent.ctorParameters = function () { return [
        { type: i1.JnyPreHttpServicesService },
        { type: JnyUserPickerService }
    ]; };
    JnyUserPickerComponent.propDecorators = {
        uidTextElement: [{ type: i0.ViewChild, args: ['uidText',] }],
        value: [{ type: i0.Input }],
        selectEmpDept: [{ type: i0.Input }],
        selectEmpName: [{ type: i0.Input }],
        valueChange: [{ type: i0.Output }],
        userInfo: [{ type: i0.Output }]
    };
    var DeptVO = /** @class */ (function () {
        function DeptVO() {
        }
        return DeptVO;
    }());
    var EmpVO = /** @class */ (function () {
        function EmpVO() {
        }
        return EmpVO;
    }());
    var LoginUserVO = /** @class */ (function () {
        function LoginUserVO() {
            this.tokenId = '';
            this.userId = '';
            this.userName = '';
            this.postId = '';
            this.postName = '';
            this.deptNo = '';
            this.deptName = '';
        }
        return LoginUserVO;
    }());

    var JnyDeptPickerService = /** @class */ (function () {
        function JnyDeptPickerService(httpService) {
            this.httpService = httpService;
        }
        //取得部門資料
        JnyDeptPickerService.prototype.getDeptList = function () {
            var url = 'osjcEmpCtrl/qryAllDept';
            return this.httpService.post(url);
        };
        return JnyDeptPickerService;
    }());
    JnyDeptPickerService.ɵprov = i0.ɵɵdefineInjectable({ factory: function JnyDeptPickerService_Factory() { return new JnyDeptPickerService(i0.ɵɵinject(i1.JnyPreHttpServicesService)); }, token: JnyDeptPickerService, providedIn: "root" });
    JnyDeptPickerService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    JnyDeptPickerService.ctorParameters = function () { return [
        { type: i1.JnyPreHttpServicesService }
    ]; };

    var JnyDeptPickerComponent = /** @class */ (function () {
        function JnyDeptPickerComponent(jnyDeptPickerService) {
            this.jnyDeptPickerService = jnyDeptPickerService;
            this.deptVOs = [];
            this.valueChange = new i0.EventEmitter();
            this.selectDept = {
                DEPTNO: "",
                DEPTNAME: ""
            };
        }
        JnyDeptPickerComponent.prototype.ngOnChanges = function (changes) {
            for (var propertyName in changes) {
                if (propertyName === "value") {
                    this.changeDept();
                }
            }
        };
        JnyDeptPickerComponent.prototype.ngOnInit = function () {
            this.getDeptList();
        };
        JnyDeptPickerComponent.prototype.changeDept = function () {
            // 元件首次載入的ngOnChanges尚未取得所有單位資料
            if (this.deptVOs.length === 0) {
                return false;
            }
            // 避免valueEmit之後又再觸發changeUser事件
            if (this.selectDept.DEPTNO === this.value) {
                return false;
            }
            this.selectDept.DEPTNO = (this.value) ? this.value.trim().toUpperCase() : '';
            this.selectDept.DEPTNAME = '---';
            var app = this;
            if (this.selectDept.DEPTNO.length > 0) {
                var fullDeptNo_1 = app.selectDept.DEPTNO;
                var deptNoLength = app.selectDept.DEPTNO.length;
                if (deptNoLength == 1)
                    fullDeptNo_1 += "000";
                else if (deptNoLength == 2)
                    fullDeptNo_1 += "00";
                else if (deptNoLength == 3)
                    fullDeptNo_1 += "0";
                this.deptVOs.forEach(function (deptVo) {
                    if (deptVo.DEPTNO.startsWith(fullDeptNo_1)) {
                        app.selectDept.DEPTNO = deptVo.DEPTNO;
                        app.selectDept.DEPTNAME = deptVo.DEPTNAME;
                        return false;
                    }
                });
            }
        };
        JnyDeptPickerComponent.prototype.getDeptList = function () {
            var _this = this;
            this.jnyDeptPickerService.getDeptList().subscribe(function (data) {
                _this.deptVOs = data.attributeMap.deptList;
                // 首次執行的ngOnChanges優先於getDeptList
                // 因此在getDeptList完成時強制執行changeDept
                _this.changeDept();
            }, function (error) { return console.log(error); });
            ;
        };
        JnyDeptPickerComponent.prototype.pickDept = function () {
            this.value = this.selectDept.DEPTNO;
            this.visible = false;
            this.valueChange.emit(this.value);
        };
        JnyDeptPickerComponent.prototype.showDeptPicker = function () {
            this.visible = true;
        };
        return JnyDeptPickerComponent;
    }());
    JnyDeptPickerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-jny-dept-picker',
                    template: "<div class=\"p-inputgroup\" style='width:160px'>\r\n  <button type=\"button\" pButton pRipple icon=\"pi pi-users\" styleClass=\"p-button-info\"\r\n    (click)=\"showDeptPicker()\"></button>\r\n  <input type=\"text\" pInputText [(ngModel)]=\"value\" (input)=\"changeDept()\" maxlength=\"4\"\r\n    class='p-inputtext p-component'>\r\n  <!--\r\n    <span class=\"p-inputgroup-addon\"><span class=\"badge badge-info mr-1\">{{selectDept.DEPTNO}}</span>{{selectDept.DEPTNAME}}</span>\r\n  -->\r\n  <span class=\"p-inputgroup-addon\">{{selectDept.DEPTNAME}}</span>\r\n</div>\r\n<p-dialog header=\"\u90E8\u9580\u9078\u55AE\" [(visible)]=\"visible\" [modal]=\"true\" [responsive]=\"true\"\r\n  [style]=\"{width: '400px', minWidth: '400px'}\" [baseZIndex]=\"9999\">\r\n  <div style=\"text-align: center\">\r\n    <!--\u56E0IE\u4E0B\u62C9\u9078\u55AEoption\u6C92\u6709click\u4E8B\u4EF6\uFF0C\u6545\u5BEB\u5728select\u4E2D-->\r\n    <select [(ngModel)]=\"selectDept\" size=\"15\" (click)=\"pickDept()\" style=\"width:100%\">\r\n      <option *ngFor=\"let deptVO of deptVOs\" [ngValue]=\"deptVO\">{{deptVO.DEPTNO + ' '+ deptVO.DEPTNAME}}</option>\r\n    </select>\r\n  </div>\r\n</p-dialog>\r\n",
                    providers: [JnyDeptPickerService],
                    styles: [""]
                },] }
    ];
    JnyDeptPickerComponent.ctorParameters = function () { return [
        { type: JnyDeptPickerService }
    ]; };
    JnyDeptPickerComponent.propDecorators = {
        value: [{ type: i0.Input }],
        selectDeptName: [{ type: i0.Input }],
        valueChange: [{ type: i0.Output }]
    };

    var JnyDialogAlertComponent = /** @class */ (function () {
        function JnyDialogAlertComponent(jnyUserPickerService) {
            var _this = this;
            this.jnyUserPickerService = jnyUserPickerService;
            this.display = false;
            this.subscription = this.jnyUserPickerService.getDialogAlertSubject().subscribe(function (obj) {
                _this.display = obj['display'];
                _this.header = obj['header'];
                _this.content = obj['content'];
            });
        }
        JnyDialogAlertComponent.prototype.ngOnInit = function () {
        };
        JnyDialogAlertComponent.prototype.ngOnDestroy = function () {
            this.subscription.unsubscribe();
        };
        return JnyDialogAlertComponent;
    }());
    JnyDialogAlertComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-jny-dialog-alert',
                    template: "<p-dialog [header]=\"header\" [(visible)]=\"display\" [modal]=\"true\" [draggable]=\"false\" [resizable]=\"false\" position=\"top\"\r\n  [style]=\"{width: '50vw'}\">\r\n  {{content}}\r\n  <p-footer>\r\n    <p-button icon=\"pi pi-check\" (click)=\"display=false\" label=\"Ok\" styleClass=\"p-button-text\"></p-button>\r\n  </p-footer>\r\n</p-dialog>\r\n",
                    styles: [""]
                },] }
    ];
    JnyDialogAlertComponent.ctorParameters = function () { return [
        { type: JnyUserPickerService }
    ]; };

    var JnyUserPickerModule = /** @class */ (function () {
        function JnyUserPickerModule() {
        }
        return JnyUserPickerModule;
    }());
    JnyUserPickerModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [JnyUserPickerComponent, JnyDialogAlertComponent, JnyDeptPickerComponent],
                    imports: [
                        forms.FormsModule,
                        common.CommonModule,
                        dialog.DialogModule,
                        button.ButtonModule
                    ],
                    exports: [JnyUserPickerComponent, JnyDeptPickerComponent, JnyDialogAlertComponent]
                },] }
    ];

    /*
     * Public API Surface of jny-user-picker
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.DeptVO = DeptVO;
    exports.EmpVO = EmpVO;
    exports.JnyDeptPickerComponent = JnyDeptPickerComponent;
    exports.JnyDeptPickerService = JnyDeptPickerService;
    exports.JnyDialogAlertComponent = JnyDialogAlertComponent;
    exports.JnyUserPickerComponent = JnyUserPickerComponent;
    exports.JnyUserPickerModule = JnyUserPickerModule;
    exports.JnyUserPickerService = JnyUserPickerService;
    exports.LoginUserVO = LoginUserVO;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=jny-user-picker.umd.js.map
